Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tools.ant.types
Class DataType

    java.lang.Object
      |
      +--org.apache.tools.ant.ProjectComponent
            |
            +--org.apache.tools.ant.types.DataType

Direct Known Subclasses:
  AbstractFileSet, AntFilterReader, Assertions, BaseSelector, Description, ExtensionAdapter, ExtensionSet, FileList, FilterChain, FilterSet, ImageOperation, Mapper, Path, PatternSet, PropertySet, RedirectorElement, RegularExpression, Substitution, XMLCatalog

public abstract class DataType
extends ProjectComponent

Base class for those classes that can appear inside the build file as stand alone data types.

This class handles the common description attribute and provides a default implementation for reference handling and checking for circular references that is appropriate for types that can not be nested inside elements of the same type (i.e. <patternset> but not <path>).

Field Summary
`protected boolean` | `checked` Deprecated. The user should not be directly referencing variable. Please use `setChecked(boolean)` or `isChecked()` instead.
`protected java.lang.String` | `description` Deprecated. The user should not be directly referencing variable. Please use `setDescription(java.lang.String)` or `getDescription()` instead.
`protected Reference` | `ref` Deprecated. The user should not be directly referencing variable. Please use `getRefid()` instead.

Fields inherited from class org.apache.tools.ant.ProjectComponent
`project`

Constructor Summary
`DataType()`

Method Summary
`protected void` | `checkAttributesAllowed()` check that it is ok to set attributes, i.e that no reference is defined
`protected void` | `checkChildrenAllowed()` check that it is ok to add children, i.e that no reference is defined
`protected BuildException` | `circularReference()` Creates an exception that indicates the user has generated a loop of data types referencing each other.
`protected void` | `dieOnCircularReference(java.util.Stack stack, Project project)` Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
`protected java.lang.Object` | `getCheckedRef(java.lang.Class requiredClass, java.lang.String dataTypeName)` Performs the check for circular references and returns the referenced object.
`java.lang.String` | `getDescription()` Return the description for the current data type.
`protected Reference` | `getRefid()` get the reference set on this object
`protected boolean` | `isChecked()`
`boolean` | `isReference()` Has the refid attribute of this element been set?
`protected BuildException` | `noChildrenAllowed()` Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
`protected void` | `setChecked(boolean checked)`
`void` | `setDescription(java.lang.String desc)` Sets a description of the current data type.
`void` | `setRefid(Reference ref)` Set the value of the refid attribute.
`protected BuildException` | `tooManyAttributes()` Creates an exception that indicates that refid has to be the only attribute if it is set.

Methods inherited from class org.apache.tools.ant.ProjectComponent
`getProject, log, log, setProject`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### description

    protected java.lang.String description

  Deprecated. The user should not be directly referencing variable. Please use `setDescription(java.lang.String)` or `getDescription()` instead.

  The description the user has set.

### ref

    protected Reference ref

  Deprecated. The user should not be directly referencing variable. Please use `getRefid()` instead.

  Value to the refid attribute.

### checked

    protected boolean checked

  Deprecated. The user should not be directly referencing variable. Please use `setChecked(boolean)` or `isChecked()` instead.

  Are we sure we don't hold circular references?

  Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

Constructor Detail

### DataType

    public DataType()

Method Detail

### setDescription

    public void setDescription(java.lang.String desc)

  Sets a description of the current data type. It will be useful in commenting what we are doing.

### getDescription

    public java.lang.String getDescription()

  Return the description for the current data type.

### isReference

    public boolean isReference()

  Has the refid attribute of this element been set?

### setRefid

    public void setRefid(Reference ref)

  Set the value of the refid attribute.

  Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do the must call `super.setRefid`.

### dieOnCircularReference

    protected void dieOnCircularReference(java.util.Stack stack,
                                          Project project)
                                   throws BuildException

  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

  If one is included, throw a BuildException created by `circularReference`.

  This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

  The general contract of this method is that it shouldn't do anything if ``checked`` is true and set it to true on exit.

    `BuildException`

### getCheckedRef

    protected java.lang.Object getCheckedRef(java.lang.Class requiredClass,
                                             java.lang.String dataTypeName)

  Performs the check for circular references and returns the referenced object.

### tooManyAttributes

    protected BuildException tooManyAttributes()

  Creates an exception that indicates that refid has to be the only attribute if it is set.

### noChildrenAllowed

    protected BuildException noChildrenAllowed()

  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

### circularReference

    protected BuildException circularReference()

  Creates an exception that indicates the user has generated a loop of data types referencing each other.

### isChecked

    protected boolean isChecked()

### setChecked

    protected void setChecked(boolean checked)

### getRefid

    protected Reference getRefid()

  get the reference set on this object

  Returns:
    the reference or null

### checkAttributesAllowed

    protected void checkAttributesAllowed()

  check that it is ok to set attributes, i.e that no reference is defined

  Throws:
    `BuildException` - if not allowed
  Since:
    Ant 1.6

### checkChildrenAllowed

    protected void checkChildrenAllowed()

  check that it is ok to add children, i.e that no reference is defined

  Throws:
    `BuildException` - if not allowed
  Since:
    Ant 1.6

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2004 Apache Software Foundation. All Rights Reserved.